<div class="main-container">
  <div class="header-section">
    <app-page-header [pageInfo]="pageHeaderInfo"></app-page-header>
  </div>
  <div class="password-reset-form-container">
    <div *ngIf="passwordResetTokenIsValid !== null">
      <ng-container *ngIf="passwordResetTokenIsValid; else passwordResetTokenIsInvalidTemplate">
        <form [formGroup]="form" class="centered-form" (ngSubmit)="updatePassword()">
          <div class="form-content">
            <div class="columns">
              <div class="column is-10">
                <div class="field">
                  <label class="label" for="newPassword"><span i18n="@@passwordReset.newPassword">New
                      password</span><span class="required-field">*</span></label>
                  <p class="control has-icons-right">
                    <input id="newPassword" class="input" type="password" formControlName="newPassword"
                      [ngClass]="{'has-error': fieldIsInvalid('newPassword'), 'is-valid': fieldIsValid('newPassword')}">
                    <span class="icon is-small is-right is-icon-success" *ngIf="fieldIsValid('newPassword')">
                      <span class="fas fa-check-circle"></span>
                    </span>
                    <span class="icon is-small is-right is-icon-warning" *ngIf="fieldIsInvalid('newPassword')">
                      <span class="fas fa-exclamation-circle"></span>
                    </span>
                  </p>

                  <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('newPassword')">
                    <div *ngIf="newPassword.errors['required']" i18n="@@form.errors.missingpassword">
                      You must enter a password.
                    </div>

                    <div *ngIf="newPassword.errors['minlength']" i18n="@@form.errors.minLength">
                      Your password must at least contain {{ passwordMinLength }} characters.
                    </div>

                    <div *ngIf="newPassword.errors['invalidCharacters']" i18n="@@form.errors.invalidCharacters">
                      Your password contains some forbidden characters (€, ô, é, è, …).
                    </div>

                    <div *ngIf="newPassword.errors['missingSpecialCharacters']"
                      i18n="@@form.errors.missingSpecialCharacters">
                      Your password must contain at least one special character.
                    </div>

                    <div *ngIf="newPassword.errors['missingUppercasedLetter']"
                      i18n="@@form.errors.missingUppercasedLetter">
                      Your password must contain at least one uppercased character.
                    </div>

                    <div *ngIf="newPassword.errors['missingLowercasedLetter']"
                      i18n="@@form.errors.missingLowercasedLetter">
                      Your password must contain at least one lowercased character.
                    </div>

                    <div *ngIf="newPassword.errors['missingNumber']" i18n="@@form.errors.missingNumber">
                      Your password must contain at least one number.
                    </div>

                    <div *ngIf="newPassword.errors['forbiddenWord']" i18n="@@form.errors.forbiddenWord">
                      Your password must not contain obvious words.
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="columns">
              <div class="column is-10">
                <div class="field">
                  <label class="label" for="newPasswordConfirmation"><span
                      i18n="@@passwordReset.newPasswordConfirmation">New
                      password confirmation</span><span class="required-field">*</span></label>
                  <p class="control has-icons-right">
                    <input id="newPasswordConfirmation" class="input" type="password"
                      formControlName="newPasswordConfirmation"
                      [ngClass]="{'has-error': newPasswordConfirmationError || fieldIsInvalid('newPasswordConfirmation'), 'is-valid': !newPasswordConfirmationError && fieldIsValid('newPasswordConfirmation')}">
                    <span class="icon is-small is-right is-icon-success"
                      *ngIf="!newPasswordConfirmationError && fieldIsValid('newPasswordConfirmation')">
                      <span class="fas fa-check-circle"></span>
                    </span>
                    <span class="icon is-small is-right is-icon-warning"
                      *ngIf="newPasswordConfirmationError || fieldIsInvalid('newPasswordConfirmation')">
                      <span class="fas fa-exclamation-circle"></span>
                    </span>
                  </p>

                  <div class="form-incorrect-field-message" *ngIf="fieldIsInvalid('newPasswordConfirmation')">
                    <div *ngIf="newPasswordConfirmation.errors['required']"
                      i18n="@@form.errors.missingConfirmationPassword">
                      You must confirm your password.
                    </div>
                  </div>
                  <div class="form-incorrect-field-message" *ngIf="newPasswordConfirmationError">
                    <div i18n="@@form.errors.passwordConfirmationError">
                      The password confirmation doesn't match with the password.
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="button-container">
            <button type="submit" class="button button-gl" [ngClass]="{'is-loading': passwordResetRequestIsPending}"
              [disabled]="passwordResetFormIsInvalid || form.disabled" i18n="@@passwordReset.resetButton">
              Reset the password
            </button>
          </div>
        </form>
      </ng-container>

      <ng-template #passwordResetTokenIsInvalidTemplate>
        <p i18n="@@passwordReset.expired" class="is-warning">
          Your link is incorrect or has expired.
        </p>
        <br>
        <p>
          <span i18n="@@passwordReset.askNewLink">Please ask for a new link </span>
          <a [routerLink]="['/', AppRoutes.passwordForgotten.uri]" i18n="@@passwordReset.here">here</a>.
        </p>
      </ng-template>
    </div>

    <div *ngIf="error">
      <p i18n="@@passwordReset.somethingWrong" class="is-warning">
        Something went wrong while verifying the validity of your link.
      </p>
      <p>
        <span i18n="@@passwordReset.retryLater">Please retry later or ask for a new link </span>
        <a [routerLink]="['/', AppRoutes.passwordForgotten.uri]" i18n="@@passwordReset.here">here</a>.
      </p>
    </div>
  </div>
</div>
